<?php
//Yay lets make a php power game for Ludum Dare 34
//Created by Sandcrawler in 48 hours for the Compo

//Yep this is some quality php, now lets exit php to be lazy and write html

?>
<html>
<head>
<title>A Growing Prince</title>
</head>
<body>
<?php

//A few variables to declare that will be used constantly.
$user_ip = str_replace(":","",$_SERVER['REMOTE_ADDR']); //We use this to track a user without logging them in we also take out the : from the ip leaving just numbers.
$file = "./saves/".$user_ip;
$cmd = $_GET['cmd'];
$id = $_GET['id'];
//Lets populate some arrays with values and names for our creatures and consumables.
$fields_m_names = array("Ladybug","Boar","Pidgeon");
$fields_c_names = array("Blueberry","Apple","Blackberry");
$rocky_m_names = array("Dragonfly","Scorpion","Bear");
$rocky_c_names = array("Elderberry","Grub","Lettuce");
$beach_m_names = array("Crab","Seagull","Whale");
$beach_c_names = array("Shellfish","Seaweed","Shrimp");

//This shouldn't be needed but its complicated and brain
//They should all be overwritten when the save file is loaded next
//Basically just here for when you complete the game and restart
$lvl = 0;
$actions = 1;
$castle = rand(1,250);
$location = 0;

//This blocks run everytime, regardless and stores the users level, action, and goal.
//Next see if the file is empty and set some information to it. Else we are going to load it.
 if(!file_exists($file))
 {//First thing first, lets check to see if the users ip has a save file. If not lets make them one
 if(!file_exists(dirname($file)))
  mkdir(dirname($file), 0777, true);
 $myfile = fopen($file, "w") or die("Unable to open file!");

  //Going to be a cheater and render this as php to the file, 
  $txt = "<?php
\$lvl = 0;
\$actions = 0;
\$castle = ".rand(1,250).";
\$location = 0;
?>
";
  fwrite($myfile, $txt);
  $cmd = "welcome";
 }
 else
 {
  include($file); //Lets now try and load our file
 }
//Some light html and dirty CSS
echo "<div style=\"display:block;width:400px;height:400px;margin-left:auto;margin-right:auto;\">
<h1 style=\"display:inline;\">A Growing Prince</h1><br>
By Sandcrawler in 48 hours for Ludum Dare #34
<div style=\"position:absolute;top:200px;width:350px;\">

";
//Now lets add some game logic
if(empty($cmd))//Empty is going to refresh the page, and basically be a move. New monster chance/consumable chance
{
 echo "While exploring you found:<br>";
 $chance = rand(0,2);
 $mob = rand(0,2);
 if($chance == 1)
 {
  if($location == 0)
  {
   echo $fields_m_names[$mob];
  }
  elseif($location == 1)
  {
   echo $rocky_m_names[$mob];
  }
  if($location == 2)
  {
   echo $beach_m_names[$mob];
  }
 }
 if($chance == 2)
 {
  if($location == 0)
  {
   echo $fields_c_names[$mob];
  }
  elseif($location == 1)
  {
   echo $rocky_c_names[$mob];
  }
  if($location == 2)
  {
   echo $beach_c_names[$mob];
  }
 }
 echo "<br>";
}
elseif($cmd == "welcome")
{
 echo "Hello Growing Prince, you need to grow bigger so that you can rescue the princess from the castle. Grow by Attacking creatures and consuming...stuff.";
}
elseif($cmd == "attack")
{
  if($location == 0)
  {
   echo "You attack the ";
   echo $fields_m_names[$id];
   echo " destroying it, and gaining 1 level.<br>";
   $lvl = $lvl + 1;
  }
  if(($location == 1) && ($lvl >= 10))
  {
   echo "You attack the ";
   echo $rocky_m_names[$id];
   echo " destroying it, and gaining 10 levels.<br>";
   $lvl = $lvl + 10;
  }
  elseif(($location == 1) && ($lvl <= 10))
  {
   echo "Your level is to low to attack anything in the Rocky Crags, you need to be level 10.<br>";
  }
  if(($location == 2) && ($lvl >= 100))
  {
   echo "You attack the ";
   echo $beach_m_names[$id];
   echo " destroying it, and gaining 15 levels.<br>";
   $lvl = $lvl + 15;
  }
  elseif(($location == 2) && ($lvl <= 100))
  {
   echo "Your level is to low to attack anything on the Beach, you need to be level 100.<br>";
  }
}
elseif($cmd == "consume")
{
  if($location == 0)
  {
   echo "You consume the ";
   echo $fields_c_names[$id];
   echo " and gain 1 level.<br>";
   $lvl = $lvl + 1;
  }
  if(($location == 1) && ($lvl >= 10))
  {
   echo "You consume the ";
   echo $rocky_c_names[$id];
   echo " and gain 10 levels.<br>";
   $lvl = $lvl + 10;
  }
  elseif(($location == 1) && ($lvl <= 10))
  {
   echo "Your level is to low to consume anything in the Rocky Crags, you need to be level 10.<br>";
  }
  if(($location == 2) && ($lvl >= 100))
  {
   echo "You consume the ";
   echo $beach_c_names[$id];
   echo " and gain 15 levels.<br>";
   $lvl = $lvl + 15;
  }
  elseif(($location == 2) && ($lvl <= 100))
  {
   echo "Your level is to low to consume anything on the Beach, you need to be level 100.<br>";
  }
}
elseif($cmd == "fields")
{
echo "You are now in the Summer Fields, good luck.";
$location = 0;
}
elseif($cmd == "rocky")
{
echo "You are now in the Rocky Crags, good luck.";
$location = 1;
}
elseif($cmd == "beach")
{
echo "You are now on the Beach, good luck.";
$location = 2;
}
elseif($cmd == "castle")//This is a bit different, we want to check if the level is equal to the castle parameter, then you rescue the princess and win the game.
{
 if($lvl >= $castle)
 {
  echo "You have rescured the princess from floor $castle of the Castle. Congraulations you have completed the game. <a href=\"index.php\">Click here if you want to do it again</a>.";
  $random_save = rand(0,5000);
  rename($file, "./saves/completed/".$user_ip."_".$random_save);
  $nosave=1;
 }
 else
 {
  echo "Your princess is on another level of this castle. Get back to growing.";
 }
}

//Now close our fixed position div and start another for the controls
echo "</div>
<div style=\"position:absolute;top:300px;\">
";
//Some navigation/game options/controls
echo "<table>
<tr><td>Movement</td><td>Action</td><td>Teleport To</td><td>Stats</td></tr>
<tr><td><a href=\"index.php\">up</a></td><td>";
//To attack or not to attack
if($chance == 1)
{
 echo "<a href=\"?cmd=attack&id=$mob\">Attack</a>";
}
else
{
 echo "Attack";
}

echo "</td><td><a href=\"?cmd=fields\">Summer Field</a></td><td>Level: $lvl</td></tr>
<tr><td><a href=\"index.php\">down</a></td><td><a href=\"index.php\">Retreat</a></td><td><a href=\"?cmd=rocky\">Rocky Crags</a></td><td>Actions: $actions</td></tr>
<tr><td><a href=\"index.php\">left</a></td><td>";
//To consume or not to consume
if($chance == 2)
{
 echo "<a href=\"?cmd=consume&id=$mob\">Consume</a>";
}
else
{
 echo "Consume";
}

echo "</td><td><a href=\"?cmd=beach\">Beach</a></td><td></td></tr>
<tr><td><a href=\"index.php\">right</a></td><td> </td><td><a href=\"?cmd=castle\">Castle</a></td><td></td></tr>
</table>
";

//Now we are going to recreate the user file with the updated numbers that may have changed on the page.
 if(file_exists($file) && ($nosave != 1))//If not empty then do it
 {//This part is a copy from earlier.
  $myfile = fopen($file, "w") or die("Unable to open file!");
  $actions = $actions + 1;//The actions goes up each page load or movement.

  //Now we render it out to php ina  file, but this time use the varables set in the above include.
  //Everything adds an action, so we can just do that here.
  $txt = "<?php
\$lvl = $lvl;
\$actions = $actions;
\$castle = $castle;
\$location = $location;
?>
";
  fwrite($myfile, $txt);
 }

//just closing our dirty styling div
echo "</div></div>";
?>
</body>
</html>
